local insert = table.insert;

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:CreateWindow(Parent, Name)
    local Window = self:CreateFrame(Parent)
    Window:SetThemedBackdrop()
    Window:SetPoint("CENTER")
    Window:SetClampedToScreen(true)
    Window:SetFrameStrata("HIGH")

    Window.CloseButton = self:CreateButton(Window)
    Window.CloseButton:Size(25, 25)
    Window.CloseButton:CloseButtonTexture();
    Window.CloseButton:SetPoint("TOPRIGHT", -(self.BorderSize + self.Padding), -(self.BorderSize + self.Padding))
    Window.CloseButton.OnClick = function(self)
        Window:Release()
        if Window.OnCloseFunc then 
            Window.OnCloseFunc()
        end 
    end

    Window.Header = self:CreateFrame(Window)
    Window.Header:Size(nil, 25)
    Window.Header:SetPoint("TOPLEFT", self.BorderSize + self.Padding, -(self.BorderSize + self.Padding))
    Window.Header:SetPoint("TOPRIGHT", Window.CloseButton, "TOPLEFT", -self.Padding, 0)
    Window.Header:SetText(Name or "", 14,"Highlight")
    Window.Header:SetThemedBackdrop()

    return Window
end
